searchNodes=[{"ref":"FileSize.html","title":"FileSize","type":"module","doc":"A file size calculator, parser and formatter. Usage You can build your own file size by creating it with a number and a unit using the new/2 function. See the &quot;Supported Units&quot; section for a list of possible unit atoms. iex&gt; FileSize.new(16, :gb) #FileSize&lt;&quot;16.0 GB&quot;&gt; Sigil There is also a sigil defined that you can use to quickly build file sizes from a number and unit symbol. Just use the FileSize module and you are ready to go. See the &quot;Supported Units&quot; section for a list of possible unit symbols. iex&gt; use FileSize ...&gt; ...&gt; ~F(16 GB) #FileSize&lt;&quot;16.0 GB&quot;&gt; From File With from_file/1 it is also possible to retrieve the size of an actual file. iex&gt; FileSize.from_file(&quot;path/to/my/file.txt&quot;) {:ok, #FileSize&lt;&quot;127.3 kB&quot;&gt;} Conversions You can convert file sizes between different units or unit systems by using the convert/2 function. Calculations You can calculate with file sizes. The particular units don&#39;t need to be the same for that. add/2 - Add two file sizes. subtract/2 - Subtracts two file sizes. Comparison For comparison the units of the particular file sizes don&#39;t need to be the same. compare/2 - Compares two file sizes and returns a value indicating whether one file size is greater than or less than the other. equals?/2 - Determines whether two file sizes are equal. lt?/2 - Determines whether file size a &lt; b. lteq?/2 - Determines whether file size a &lt;= b. gt?/2 - Determines whether file size a &gt; b. gteq?/2 - Determines whether file size a &gt;= b. To sort a collection of file sizes from smallest to greatest, you can use lteq?/2 as sort function. To sort descending use gteq?/2. iex&gt; sizes = [~F(16 GB), ~F(100 Mbit), ~F(27.4 MB), ~F(16 Gbit)] ...&gt; Enum.sort(sizes, &amp;FileSize.lteq?/2) [#FileSize&lt;&quot;100.0 Mbit&quot;&gt;, #FileSize&lt;&quot;27.4 MB&quot;&gt;, #FileSize&lt;&quot;16.0 Gbit&quot;&gt;, #FileSize&lt;&quot;16.0 GB&quot;&gt;] Supported Units Bit-based SI (Système international d&#39;unités) AtomSymbolNameFactor :bitbitBits1 :kbitkbitKilobits1000 :mbitMbitMegabits1000^2 :gbitGBitGigabits1000^3 :tbitTBitTerabits1000^4 :pbitPBitPetabits1000^5 :ebitEBitExabits1000^6 :zbitZBitZetabits1000^7 :ybitYBitYottabits1000^8 IEC (International Electrotechnical Commission) AtomSymbolNameFactor :bitBitBits1 :kibitKibitKibibits1024 :mibitMibitMebibits1024^2 :gibitGibitGibibits1024^3 :tibitTibitTebibits1024^4 :pibitPibitPebibits1024^5 :eibitEibitExbibits1024^6 :zibitZibitZebibits1024^7 :yibitYibitYobibits1024^8 Byte-based The most common unit of digital information. A single Byte represents 8 Bits. SI (Système international d&#39;unités) AtomSymbolNameFactor :bBBytes1 :kbkBKilobytes1000 :mbMBMegabytes1000^2 :gbGBGigabytes1000^3 :tbTBTerabytes1000^4 :pbPBPetabytes1000^5 :ebEBExabytes1000^6 :zbZBZetabytes1000^7 :ybYBYottabytes1000^8 IEC (International Electrotechnical Commission) AtomSymbolNameFactor :bBBytes1 :kibKiBKibibytes1024 :mibMiBMebibytes1024^2 :gibGiBGibibytes1024^3 :tibTiBTebibytes1024^4 :pibPiBPebibytes1024^5 :eibEiBExbibytes1024^6 :zibZiBZebibytes1024^7 :yibYiBYobibytes1024^8"},{"ref":"FileSize.html#__config__/0","title":"FileSize.__config__/0","type":"function","doc":"Gets the configuration."},{"ref":"FileSize.html#add/2","title":"FileSize.add/2","type":"function","doc":"See FileSize.Calculable.add/2."},{"ref":"FileSize.html#add/3","title":"FileSize.add/3","type":"function","doc":"Adds two file sizes like add/2 and converts the result to the specified unit. Example iex&gt; FileSize.add(FileSize.new(1, :kb), FileSize.new(2, :kb), :b) #FileSize&lt;&quot;3000 B&quot;&gt; iex&gt; FileSize.add(FileSize.new(1, :kb), FileSize.new(2, :kb), {:system, :iec}) #FileSize&lt;&quot;2.9296875 KiB&quot;&gt;"},{"ref":"FileSize.html#change_unit_system/2","title":"FileSize.change_unit_system/2","type":"function","doc":"Converts the given file size to a given unit system."},{"ref":"FileSize.html#compare/2","title":"FileSize.compare/2","type":"function","doc":"See FileSize.Comparable.compare/2."},{"ref":"FileSize.html#convert/2","title":"FileSize.convert/2","type":"function","doc":"Converts the given file size to a given unit or unit system. Examples iex&gt; FileSize.convert(FileSize.new(2, :kb), :b) #FileSize&lt;&quot;2000 B&quot;&gt; iex&gt; FileSize.convert(FileSize.new(2000, :b), :kb) #FileSize&lt;&quot;2.0 kB&quot;&gt; iex&gt; FileSize.convert(FileSize.new(20, :kb), :kbit) #FileSize&lt;&quot;160.0 kbit&quot;&gt; iex&gt; FileSize.convert(FileSize.new(2, :kb), {:system, :iec}) #FileSize&lt;&quot;1.953125 KiB&quot;&gt; iex&gt; FileSize.convert(FileSize.new(2, :kib), {:system, :si}) #FileSize&lt;&quot;2.048 kB&quot;&gt; iex&gt; FileSize.convert(FileSize.new(2000, :b), :unknown) ** (FileSize.InvalidUnitError) Invalid unit: :unknown iex&gt; FileSize.convert(FileSize.new(2, :b), {:system, :unknown}) ** (FileSize.InvalidUnitSystemError) Invalid unit system: :unknown"},{"ref":"FileSize.html#equals?/2","title":"FileSize.equals?/2","type":"function","doc":"Determines whether two file sizes are equal. Examples iex&gt; FileSize.equals?(FileSize.new(2, :b), FileSize.new(16, :bit)) true iex&gt; FileSize.equals?(FileSize.new(2, :b), FileSize.new(2, :b)) true iex&gt; FileSize.equals?(FileSize.new(1, :b), FileSize.new(2, :b)) false"},{"ref":"FileSize.html#format/2","title":"FileSize.format/2","type":"function","doc":"See FileSize.Formatter.format/2."},{"ref":"FileSize.html#from_bits/2","title":"FileSize.from_bits/2","type":"function","doc":"Builds a new file size from the given number of bits. Example iex&gt; FileSize.from_bits(2000) #FileSize&lt;&quot;2.0 kbit&quot;&gt; iex&gt; FileSize.from_bits(2000, {:system, :iec}) #FileSize&lt;&quot;1.953125 Kibit&quot;&gt; iex&gt; FileSize.from_bits(16, :b) #FileSize&lt;&quot;2 B&quot;&gt; iex&gt; FileSize.from_bits(16, :unknown) ** (FileSize.InvalidUnitError) Invalid unit: :unknown"},{"ref":"FileSize.html#from_bytes/2","title":"FileSize.from_bytes/2","type":"function","doc":"Builds a new file size from the given number of bytes. Example iex&gt; FileSize.from_bytes(2000) #FileSize&lt;&quot;2.0 kB&quot;&gt; iex&gt; FileSize.from_bytes(2000, {:system, :iec}) #FileSize&lt;&quot;1.953125 KiB&quot;&gt; iex&gt; FileSize.from_bytes(2000, :kb) #FileSize&lt;&quot;2.0 kB&quot;&gt; iex&gt; FileSize.from_bytes(2000, :kbit) #FileSize&lt;&quot;16.0 kbit&quot;&gt; iex&gt; FileSize.from_bytes(2000, :unknown) ** (FileSize.InvalidUnitError) Invalid unit: :unknown"},{"ref":"FileSize.html#from_file/2","title":"FileSize.from_file/2","type":"function","doc":"Determines the size of the file at the given path. Examples iex&gt; FileSize.from_file(&quot;path/to/my/file.txt&quot;) {:ok, #FileSize&lt;&quot;133.7 kB&quot;&gt;} iex&gt; FileSize.from_file(&quot;path/to/my/file.txt&quot;, {:system, :iec}) {:ok, #FileSize&lt;&quot;133.7 KiB&quot;&gt;} iex&gt; FileSize.from_file(&quot;path/to/my/file.txt&quot;, :mb) {:ok, #FileSize&lt;&quot;0.13 MB&quot;&gt;} iex&gt; FileSize.from_file(&quot;not/existing/file.txt&quot;) {:error, :enoent}"},{"ref":"FileSize.html#from_file!/2","title":"FileSize.from_file!/2","type":"function","doc":"Determines the size of the file at the given path. Raises when the file could not be found. Examples iex&gt; FileSize.from_file!(&quot;path/to/my/file.txt&quot;) #FileSize&lt;&quot;133.7 kB&quot;&gt; iex&gt; FileSize.from_file!(&quot;path/to/my/file.txt&quot;, {:system, :iec}) #FileSize&lt;&quot;133.7 KiB&quot;&gt; iex&gt; FileSize.from_file!(&quot;path/to/my/file.txt&quot;, :mb) #FileSize&lt;&quot;0.13 MB&quot;&gt; iex&gt; FileSize.from_file!(&quot;not/existing/file.txt&quot;) ** (File.Error) could not read file stats &quot;not/existing/file.txt&quot;: no such file or directory"},{"ref":"FileSize.html#gt?/2","title":"FileSize.gt?/2","type":"function","doc":"Determines whether the first file size is greater than the second one. Examples iex&gt; FileSize.gt?(FileSize.new(2, :b), FileSize.new(1, :b)) true iex&gt; FileSize.gt?(FileSize.new(1, :b), FileSize.new(2, :b)) false"},{"ref":"FileSize.html#gteq?/2","title":"FileSize.gteq?/2","type":"function","doc":"Determines whether the first file size is less or equal to than the second one. Examples iex&gt; FileSize.gteq?(FileSize.new(2, :b), FileSize.new(1, :b)) true iex&gt; FileSize.gteq?(FileSize.new(1, :b), FileSize.new(1, :b)) true iex&gt; FileSize.gteq?(FileSize.new(1, :b), FileSize.new(2, :b)) false"},{"ref":"FileSize.html#lt?/2","title":"FileSize.lt?/2","type":"function","doc":"Determines whether the first file size is less than the second one. Examples iex&gt; FileSize.lt?(FileSize.new(1, :b), FileSize.new(2, :b)) true iex&gt; FileSize.lt?(FileSize.new(2, :b), FileSize.new(1, :b)) false"},{"ref":"FileSize.html#lteq?/2","title":"FileSize.lteq?/2","type":"function","doc":"Determines whether the first file size is less or equal to than the second one. Examples iex&gt; FileSize.lteq?(FileSize.new(1, :b), FileSize.new(2, :b)) true iex&gt; FileSize.lteq?(FileSize.new(1, :b), FileSize.new(1, :b)) true iex&gt; FileSize.lteq?(FileSize.new(2, :b), FileSize.new(1, :b)) false"},{"ref":"FileSize.html#new/2","title":"FileSize.new/2","type":"function","doc":"Builds a new file size. Raises when the given unit could not be found. Examples iex&gt; FileSize.new(2.5, :mb) #FileSize&lt;&quot;2.5 MB&quot;&gt; iex&gt; FileSize.new(214, :kib) #FileSize&lt;&quot;214.0 KiB&quot;&gt; iex&gt; FileSize.new(3, :bit) #FileSize&lt;&quot;3 bit&quot;&gt;"},{"ref":"FileSize.html#parse/1","title":"FileSize.parse/1","type":"function","doc":"See FileSize.Parser.parse/1."},{"ref":"FileSize.html#parse!/1","title":"FileSize.parse!/1","type":"function","doc":"See FileSize.Parser.parse!/1."},{"ref":"FileSize.html#scale/2","title":"FileSize.scale/2","type":"function","doc":"Converts the given file size to the most appropriate unit. Examples iex&gt; FileSize.scale(FileSize.new(2000, :b)) #FileSize&lt;&quot;2.0 kB&quot;&gt; iex&gt; FileSize.scale(FileSize.new(2_000_000, :kb)) #FileSize&lt;&quot;2.0 GB&quot;&gt; iex&gt; FileSize.scale(FileSize.new(2_000_000, :kb), :iec) #FileSize&lt;&quot;1.862645149230957 GiB&quot;&gt;"},{"ref":"FileSize.html#subtract/2","title":"FileSize.subtract/2","type":"function","doc":"See FileSize.Calculable.subtract/2."},{"ref":"FileSize.html#subtract/3","title":"FileSize.subtract/3","type":"function","doc":"Subtracts two file sizes like subtract/2 and converts the result to the specified unit. Example iex&gt; FileSize.subtract(FileSize.new(2, :b), FileSize.new(6, :bit), :bit) #FileSize&lt;&quot;10 bit&quot;&gt; iex&gt; FileSize.subtract(FileSize.new(3, :kb), FileSize.new(1, :kb), {:system, :iec}) #FileSize&lt;&quot;1.953125 KiB&quot;&gt;"},{"ref":"FileSize.html#t:iec_unit/0","title":"FileSize.iec_unit/0","type":"type","doc":"A type that defines the IEC bit and byte units."},{"ref":"FileSize.html#t:si_unit/0","title":"FileSize.si_unit/0","type":"type","doc":"A type that defines the SI bit and byte units."},{"ref":"FileSize.html#t:t/0","title":"FileSize.t/0","type":"type","doc":"A type that is a union of the bit and byte types."},{"ref":"FileSize.html#t:unit/0","title":"FileSize.unit/0","type":"type","doc":"A type that is a union of the bit and byte unit types."},{"ref":"FileSize.html#t:unit_symbol/0","title":"FileSize.unit_symbol/0","type":"type","doc":"A type that represents a unit symbol."},{"ref":"FileSize.html#t:unit_system/0","title":"FileSize.unit_system/0","type":"type","doc":"A type that contains the available unit systems."},{"ref":"FileSize.InvalidUnitError.html","title":"FileSize.InvalidUnitError","type":"exception","doc":"An exception that raises when converting to an unknown unit."},{"ref":"FileSize.InvalidUnitSystemError.html","title":"FileSize.InvalidUnitSystemError","type":"exception","doc":"An exception that raises when converting to an unknown unit system."},{"ref":"FileSize.ParseError.html","title":"FileSize.ParseError","type":"exception","doc":"An exception that raises when a value could not be parsed into a file size."},{"ref":"FileSize.Bit.html","title":"FileSize.Bit","type":"module","doc":"A struct that represents a file size in bits as lowest possible value."},{"ref":"FileSize.Bit.html#t:iec_unit/0","title":"FileSize.Bit.iec_unit/0","type":"type","doc":"A type defining the available IEC units."},{"ref":"FileSize.Bit.html#t:si_unit/0","title":"FileSize.Bit.si_unit/0","type":"type","doc":"A type defining the available SI units."},{"ref":"FileSize.Bit.html#t:t/0","title":"FileSize.Bit.t/0","type":"type","doc":"The bit type."},{"ref":"FileSize.Bit.html#t:unit/0","title":"FileSize.Bit.unit/0","type":"type","doc":"A union type combining the available IEC and SI units."},{"ref":"FileSize.Byte.html","title":"FileSize.Byte","type":"module","doc":"A struct that represents a file size in bytes as lowest possible value, which is a chunk of 8 bits each."},{"ref":"FileSize.Byte.html#t:iec_unit/0","title":"FileSize.Byte.iec_unit/0","type":"type","doc":"A type defining the available IEC units."},{"ref":"FileSize.Byte.html#t:si_unit/0","title":"FileSize.Byte.si_unit/0","type":"type","doc":"A type defining the available SI units."},{"ref":"FileSize.Byte.html#t:t/0","title":"FileSize.Byte.t/0","type":"type","doc":"The byte type."},{"ref":"FileSize.Byte.html#t:unit/0","title":"FileSize.Byte.unit/0","type":"type","doc":"A union type combining the available IEC and SI units."},{"ref":"FileSize.Formatter.html","title":"FileSize.Formatter","type":"module","doc":"A module that provides functions to convert file sizes to human-readable strings."},{"ref":"FileSize.Formatter.html#format/2","title":"FileSize.Formatter.format/2","type":"function","doc":"Formats a file size in a human-readable format, allowing customization of the formatting. Options :symbols - Allows using your own unit symbols. Must be a map that contains the unit names as keys (as defined by FileSize.unit/0) and the unit symbol strings as values. Missing entries in the map are filled with the internal unit symbols from FileSize.Units.unit_infos/0. Other options customize the number format and are forwarded to Number.Delimit.number_to_delimited/2. The default precision for numbers is 0. Global Configuration You can also define your custom symbols globally. config :file_size, :symbols, %{b: &quot;Byte&quot;, kb: &quot;KB&quot;} The same is possible for number formatting. config :file_size, :number_format, precision: 2, delimiter: &quot;,&quot;, separator: &quot;.&quot; Or globally for the number library. config :number, delimit: [precision: 2, delimiter: &quot;,&quot;, separator: &quot;.&quot;]"},{"ref":"FileSize.Formatter.html#format_simple/1","title":"FileSize.Formatter.format_simple/1","type":"function","doc":"Formats the given size ignoring all user configuration. The result of this function can be passed back to FileSize.parse/1 and is also used by the implementations of the Inspect and String.Chars protocols."},{"ref":"FileSize.Parser.html","title":"FileSize.Parser","type":"module","doc":"A module that provides functions to convert values to file sizes."},{"ref":"FileSize.Parser.html#parse/1","title":"FileSize.Parser.parse/1","type":"function","doc":"Converts the given value into a FileSize.Bit or FileSize.Byte. Returns a tuple containing the status and value or error."},{"ref":"FileSize.Parser.html#parse!/1","title":"FileSize.Parser.parse!/1","type":"function","doc":"Converts the given value into a FileSize.Bit or FileSize.Byte. Returns the value on success or raises FileSize.ParseError on error."},{"ref":"FileSize.Sigil.html","title":"FileSize.Sigil","type":"module","doc":"Provides a sigil that you can use as shortcut to define file sizes easily."},{"ref":"FileSize.Sigil.html#sigil_F/2","title":"FileSize.Sigil.sigil_F/2","type":"function","doc":"A sigil function that you can use as shortcut to define file sizes easily. Examples iex&gt; ~F(16 kB) #FileSize&lt;&quot;16.0 kB&quot;&gt; iex&gt; ~F(8 Mibit) #FileSize&lt;&quot;8.0 Mibit&quot;&gt;"},{"ref":"FileSize.Calculable.html","title":"FileSize.Calculable","type":"protocol","doc":"A protocol that defines calculations that are possible on file sizes."},{"ref":"FileSize.Calculable.html#add/2","title":"FileSize.Calculable.add/2","type":"function","doc":"Adds two file sizes. Examples iex&gt; FileSize.add(FileSize.new(1, :kb), FileSize.new(2, :kb)) #FileSize&lt;&quot;3.0 kB&quot;&gt; iex&gt; FileSize.add(FileSize.new(1, :b), FileSize.new(4, :bit)) #FileSize&lt;&quot;12 bit&quot;&gt; iex&gt; FileSize.add(FileSize.new(4, :bit), FileSize.new(1, :b)) #FileSize&lt;&quot;12 bit&quot;&gt; iex&gt; FileSize.add(FileSize.new(4, :mb), FileSize.new(200, :kb)) #FileSize&lt;&quot;4.2 MB&quot;&gt;"},{"ref":"FileSize.Calculable.html#subtract/2","title":"FileSize.Calculable.subtract/2","type":"function","doc":"Subtracts two file sizes. Examples iex&gt; FileSize.subtract(FileSize.new(3, :kb), FileSize.new(1, :kb)) #FileSize&lt;&quot;2.0 kB&quot;&gt; iex&gt; FileSize.subtract(FileSize.new(1, :b), FileSize.new(4, :bit)) #FileSize&lt;&quot;4 bit&quot;&gt;"},{"ref":"FileSize.Calculable.html#t:t/0","title":"FileSize.Calculable.t/0","type":"type","doc":""},{"ref":"FileSize.Comparable.html","title":"FileSize.Comparable","type":"protocol","doc":"A protocol that allows comparison of two file sizes."},{"ref":"FileSize.Comparable.html#compare/2","title":"FileSize.Comparable.compare/2","type":"function","doc":"Compares two file sizes and returns a value indicating whether the first value is less than, greater than or equal to the second one. For possible return values, see comparison_result/0."},{"ref":"FileSize.Comparable.html#t:comparison_result/0","title":"FileSize.Comparable.comparison_result/0","type":"type","doc":"A type that describes the value that is returned as comparison result of two file sizes. The value -1 indicates that the first value is less than the second one. 1 means thta the first value is greater than the second one. 0 indicates equality."},{"ref":"FileSize.Comparable.html#t:t/0","title":"FileSize.Comparable.t/0","type":"type","doc":""},{"ref":"FileSize.Convertible.html","title":"FileSize.Convertible","type":"protocol","doc":"A protocol that defines functions to convert file sizes to other units."},{"ref":"FileSize.Convertible.html#convert/2","title":"FileSize.Convertible.convert/2","type":"function","doc":"Converts the given file size to a given unit. Examples iex&gt; FileSize.convert(FileSize.new(2, :kb), :b) #FileSize&lt;&quot;2000 B&quot;&gt; iex&gt; FileSize.convert(FileSize.new(2000, :b), :kb) #FileSize&lt;&quot;2.0 kB&quot;&gt; iex&gt; FileSize.convert(FileSize.new(20, :kb), :kbit) #FileSize&lt;&quot;160.0 kbit&quot;&gt; iex&gt; FileSize.convert(FileSize.new(2000, :b), :unknown) ** (FileSize.InvalidUnitError) Invalid unit: :unknown"},{"ref":"FileSize.Convertible.html#new/2","title":"FileSize.Convertible.new/2","type":"function","doc":"Puts the normalized value in the given file size struct, finalizing the struct creation."},{"ref":"FileSize.Convertible.html#normalized_value/1","title":"FileSize.Convertible.normalized_value/1","type":"function","doc":"Gets the normalized value from the given file size struct."},{"ref":"FileSize.Convertible.html#t:t/0","title":"FileSize.Convertible.t/0","type":"type","doc":""},{"ref":"readme.html","title":"File Size","type":"extras","doc":"File Size A file size calculator, parser and formatter."},{"ref":"readme.html#prerequisites","title":"File Size - Prerequisites","type":"extras","doc":"Erlang 20 or greater Elixir 1.8 or greater"},{"ref":"readme.html#installation","title":"File Size - Installation","type":"extras","doc":"If available in Hex, the package can be installed by adding file_size to your list of dependencies in mix.exs: def deps do [ {:file_size, &quot;~&gt; 1.3.0&quot;} ] end"},{"ref":"readme.html#docs","title":"File Size - Docs","type":"extras","doc":"Documentation is available on HexDocs."}]